unit RunString;

///////////////////////////////////////////////////////////////////////
//                                                                   //
//                                             //
//                                                                   //
//  -    .  "Delphi:  "          //
//                                                                   //
//  .. 2006                                              //
// sadovoya@mtu-net.ru                                               //
// sadovoya.narod.ru                                                 //
//                                                                   //
///////////////////////////////////////////////////////////////////////

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, StdCtrls,

  ExtCtrls, StrUtils;// 


type
  TRunString = class(TCustomLabel)
  private
    FTimer: TTimer;
    procedure MoveText(Sender: TObject);
    function GetSpeed: Integer;
    procedure SetSpeed(MSec: Integer);
  protected
  public
    constructor Create(AOwner: TComponent); override;
  published
    property AutoSize;
    property Alignment;
    property Transparent;
    property Wordwrap;
    property Caption;
    property Font;
    property Speed: Integer read GetSpeed write SetSpeed;
end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Samples', [TRunString]);
end;

constructor TRunString.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FTimer := TTimer.Create(Self);
  FTimer.OnTimer := MoveText;
  FTimer.Interval :=300;
  FTimer.Enabled := True;
end;

procedure TRunString.MoveText(Sender: TObject);
begin
  Caption := RightStr(Caption, Length(Caption)-1) + Caption[1];
end;

function TRunString.GetSpeed: Integer;
begin
  Result := FTimer.Interval;
end ;

procedure TRunString.SetSpeed(MSec: Integer);
begin
  FTimer.Interval := MSec;
end;


end.
